package edu.uci.ics.asterix.metadata.api;

/*
 * Copyright 2009-2013 by The Regents of the University of California
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * you may obtain a copy of the License from
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import java.util.Set;

import edu.uci.ics.asterix.metadata.cluster.IClusterManagementWorkResponse;
import edu.uci.ics.asterix.om.util.AsterixClusterProperties.State;

public interface IClusterEventsSubscriber {

    /**
     * @param deadNodeIds
     * @return
     */
    public Set<IClusterManagementWork> notifyNodeFailure(Set<String> deadNodeIds);

    /**
     * @param joinedNodeId
     * @return
     */
    public Set<IClusterManagementWork> notifyNodeJoin(String joinedNodeId);

    /**
     * @param response
     */
    public void notifyRequestCompletion(IClusterManagementWorkResponse response);

    /**
     * @param previousState
     * @param newState
     */
    public void notifyStateChange(State previousState, State newState);

}
